<!DOCTYPE html>
<html lang="en">

<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title>Wiki-readability</title>
	<link rel="shortcut icon" href="./static/favicon.ico">
	<meta name="viewport" content="width = device-width, initial-scale=1, user-scalable = no" />
	<link href="https://tools-static.wmflabs.org/fontcdn/css?family=Merriweather:400,400italic,700,700italic&subset=latin" rel="stylesheet" type="text/css">
	<link href='https://tools-static.wmflabs.org/fontcdn/css?family=Lato:400,400italic,700,700italic&subset=latin' rel='stylesheet' type='text/css'>
	<link href="https://tools-static.wmflabs.org/cdnjs/ajax/libs/jqueryui/1.13.2/themes/base/jquery-ui.min.css" rel="stylesheet" type="text/css">
	<link rel="stylesheet" href="./static/style.css" />
	<style>
      .above-threshold {color: black;}
      .below-threshold {color: silver;}
      /*p { text-indent: 30px; }*/
    </style>

</head>

<body>
	<script type="text/javascript">
		var body = document.body;
		body.classList.add('js');
	</script>

	<div id="origin_bar">
		<div class="boxwidth--1-1 padded--left padded--right">
			<a href="https://research.wikimedia.org/" class="origin_title"><img src="./static/Wikimedia-Foundation-logo.svg" alt="Wikimedia Foundation logo" />Wikimedia Research</a>
		</div>
	</div>

	<article id="tool_holder">
		<!-- Header / Start -->
		<div id="tool_header--holder" class="boxwidth--1-1 padded--left padded--right">
			<header id="tool_header">
				<!-- Tool name -->
				<h1>Multilingual model to score readability of Wikipedia articles</h1>
				<div class="meta">
					<div class="disclaimer note">
						No guarantees are made that this tool will be maintained.
						This is an experimental tool hosted on <a href="https://wikitech.wikimedia.org/wiki/Portal:Toolforge">Toolforge</a>.
						No additional personal data is collected by this tool per the Cloud Services
							<a href="https://wikitech.wikimedia.org/wiki/Wikitech:Cloud_Services_Terms_of_use" target="_blank" rel="noopener">Terms of Use</a>.
					</div>
					<div class="description padded--right">
						<p>	This tool aims to quantify the readability of Wikipedia articles in different languages.</p>
						<p> Existing approaches based on <a href="https://en.wikipedia.org/wiki/Readability#Popular_readability_formulas"> readability formulas</a>  use simple text-based features such average sentence length to yield a score that captures the difficulty of a text. Often this score is given as an approximate representation of the US grade level needed to comprehend the text (such as the <a href="https://en.wikipedia.org/wiki/Flesch%E2%80%93Kincaid_readability_tests#Flesch%E2%80%93Kincaid_grade_level">Flesch-Kincaid grade level</a>). The problem is that these formulas are often tailored specifically towards English and are thus not easily applicable for texts of other languages.
					  </p>
						<p> We developed a multi-lingual model for scoring readability of articles supporting more than 100 languages. You can read more about the model here: the <a href="https://meta.wikimedia.org/wiki/Machine_learning_models/Production/Multilingual_readability_model_card">model card</a>, the <a href="https://aclanthology.org/2024.acl-long.342/">research paper</a>, or the <a href="https://meta.wikimedia.org/wiki/Research:Multilingual_Readability_Research">project page</a> on MetaWiki.
						</p>
				  		<p> You can test out the tool below with your own article -- e.g., Toni Morrison (en) -- or leave the title field blank for a random article. The model's output will consist of: i) a readability score ranging from negative (easy to read) to positive (difficult to read), ii) a predicted grade level (i.e. roughly capturing the number of years of education generally required to understand this text) similar to the  <a href="https://en.wikipedia.org/wiki/Flesch%E2%80%93Kincaid_readability_tests#Flesch%E2%80%93Kincaid_grade_level">Flesch-Kincaid grade level</a> for English.</p>

						<!-- </p> -->
						<!-- <p>	  </p> -->
					</div>
				</div>
			</header>
		</div>

		<div class="separator"></div>

		<section id="readability" class="boxwidth--1-1 padded--left padded--right">
					<main id="tool_main">
						<section class="form">
							<form action="#results">
								<div class="cols cols3">
									<div class="col col1">
										{% if lang %}
										<label class="placeholder"><span class="field_name">Language code -- e.g., en for English</span>
											<input type="text" value="{{lang}}" placeholder="Placeholder text" id="lang"/>
										</label>
										{% else %}
										<label class="placeholder"><span class="field_name">Language code -- e.g., en for English</span>
											<input type="text" value="" placeholder="Placeholder text" id="lang"/>
										</label>
										{% endif %}
									</div>
									<div class="col col1">
										{% if page_title %}
										<label class="placeholder"><span class="field_name">Article title -- e.g., Toni Morrison</span>
											<input type="text" value="{{page_title}}" placeholder="Placeholder text" id="page_title"/>
										</label>
										{% else %}
										<label class="placeholder"><span class="field_name">Article title -- e.g., Toni Morrison</span>
											<input type="text" value="" placeholder="Placeholder text" id="page_title"/>
										</label>
										{% endif %}
									</div>
									<div class="col col1">
										<span class="field_name"></span>
										<input type="submit" value="Submit" id="btnSubmit" />
									</div>
								</div>
							</form>
						</section>
						<section id="results">
							<div class="cols cols3">
								<div class="col col3">
									<section class="text" id="readability-results">
										<!-- Empty section to hold results -->
									</section>
								</div>
							</div>
		            	</section>
					</main>
				</section>
			</article>

	<footer id="tool_footer">
		<div id="tool_footer-in" class="boxwidth--1-1 padded--left padded--right">
			<p>Experimental tool developed by <span class="tool-author"><a href="https://meta.wikipedia.org/wiki/User:MGerlach_(WMF)">MGerlach (WMF)</a> as part of <a href="https://research.wikimedia.org/">Wikimedia Research</a></span>.</p>
			<ul>
				<li><a href="https://gitlab.wikimedia.org/repos/research/readability-api">View Source</a></li>
				<li><a href="https://meta.wikimedia.org/wiki/Research:Multilingual_Readability_Research">Meta</a></li>
				<li><a href="https://gitlab.wikimedia.org/repos/research/readability-api/-/blob/main/LICENSE">License</a></li>
			</ul>
		</div>
	</footer>



		<script type="text/javascript" src="https://tools-static.wmflabs.org/cdnjs/ajax/libs/jquery/3.5.0/jquery.min.js"></script>
		<script type="text/javascript" src="https://tools-static.wmflabs.org/cdnjs/ajax/libs/jqueryui/1.13.2/jquery-ui.min.js"></script>
		<script type="text/javascript">
			$(document).ready(function() {
				$('form label.placeholder').each(function() {
					if (!$('input, textarea, select', this).val()) {
		 				$(this).addClass('off');
					}
					$(this).on('focusin', function() {
						$(this).removeClass('off');
					});
					$(this).on('focusout', function() {
						if (!$('input, textarea, select', this).val()) {
							$(this).addClass('off');
						}
					});
					$('*[placeholder]', this).attr('placeholder', '');
				});
			});
		</script>

	<script type="text/javascript">
		$('#btnSubmit').click(function (e) {
		   e.preventDefault(); queryReadabilityAPI();
		});
		window.onload = function() {
			if (document.getElementById('lang').value && document.getElementById('page_title').value) {
				queryInlinksAPI();
			}
		}
		$( function() {
			$( "#page_title" ).autocomplete({
				source: function( request, response ) {
					$.ajax( {
						url: "https://" + document.getElementById('lang').value + ".wikipedia.org/w/api.php",
						data: {
							action: "opensearch",
							search: request.term,
							limit: 5,
							namespace: 0,
							format: "json",
							origin: "*"
						},
						success: function(data) {
							response($.map( data[1], function( item ) {
								return {
									label: item,
									value: item
								}
							}));
						}
					} );
				},
				minLength: 2,
				delay: 300  // milliseconds
			} );
		});

		var render_results = function(data) {
			$("#readability-results").empty();
			// $("#readability-results").append("<br><p> Success </p>")
			if ("Error" in data) {
				$("#readability-results").append("<br><p>Error: " + data["Error"] + "</p>");
			}
			else {
				$("#readability-results").append('<br><h3><a href="' + data["article"] + '">' + data["article"] + '</a></h3>');
				$("#readability-results").append("<ul>");

				$("#readability-results").append("<li> Readability score (<0:easy ... >0:difficult): "+ data["results"]["readability_score"] +'</li>');
				$("#readability-results").append('<li> Predicted grade level (as in the <a href="https://en.wikipedia.org/wiki/Flesch%E2%80%93Kincaid_readability_tests#Flesch%E2%80%93Kincaid_grade_level">Flesch-Kincaid grade level</a>): '+ data["results"]["predicted_grade_level"] +'</li>');

				$("#readability-results").append("</ul>");
			}
		}

		var update_title = function(data) {
			document.getElementById('page_title').value = data['query']['random'][0]['title'];
			document.getElementById('page_title').parentNode.className = 'placeholder';
		}

		function queryReadabilityAPI() {
			if (document.getElementById('lang').value && !document.getElementById('page_title').value) {
				var randomPageQueryURL = "https://" + document.getElementById('lang').value + ".wikipedia.org/w/api.php?action=query&format=json&list=random&rnlimit=1&rnnamespace=0&origin=*";
				$.ajax(randomPageQueryURL, {success: update_title.bind(this),
								error: function(jqxmlhr, status, error){console.log(status + ": " + error)},
								async: false
								}
					);
			}
			var queryUrl = "https://readability.toolforge.org/api/v1?lang=" + document.getElementById('lang').value+"&title=" + document.getElementById('page_title').value;
			$.ajax(queryUrl, {success: render_results.bind(this),
							  error: function(jqxmlhr, status, error){console.log(status + ": " + error)}
							  }
				  );
	    }

	</script>

</body>

</html>
